package test;

import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.MapMeta;
import org.bukkit.map.MapCanvas;
import org.bukkit.map.MapRenderer;
import org.bukkit.map.MapView;
import org.bukkit.map.MinecraftFont;
import org.bukkit.plugin.java.JavaPlugin;

/**
 * Created by HAlex on 16/07/2018 15:32
 */
public class Main extends JavaPlugin implements Listener {

    @Override
    public void onEnable() {
        getServer().getPluginManager().registerEvents(this, this);
    }

    @SuppressWarnings("deprecation")
    @EventHandler
    public void onCommand(PlayerCommandPreprocessEvent event) {
        if (event.getMessage().equalsIgnoreCase("/test")) {
            event.setCancelled(true);

            Player p = event.getPlayer();
            MapView view = Bukkit.createMap(p.getWorld());

            for (MapRenderer renderer : view.getRenderers()) view.removeRenderer(renderer);

            view.addRenderer(new MapRenderer() {
                @Override
                public void render(MapView view, MapCanvas canvas, Player player) {
                    player.sendMessage("Rendering...");
                    canvas.drawText(0, 0, MinecraftFont.Font, "TEST 1.13");
                }
            });

            ItemStack item = new ItemStack(Material.FILLED_MAP);
            MapMeta meta = (MapMeta) item.getItemMeta();
            meta.setMapId(view.getId());
            item.setItemMeta(meta);
            p.getInventory().addItem(item);
        }
    }
}
